/**
 * @file camera_control.hpp
 * @brief Camera movement class
 *
 * @author Eric Butler (edbutler)
 */

#ifndef _462_APPLICATION_CAMERA_CONTROL_HPP_
#define _462_APPLICATION_CAMERA_CONTROL_HPP_

#include "application/application.hpp"
#include "scene/camera.hpp"
#include <string>

namespace _462 {

class CameraControl
{
public:

    CameraControl();

    ~CameraControl();

    void on_mouse_press( Window* window, Application::MouseButton button, int x, int y, size_t modifiers, bool pressed );

    void on_mouse_move( Window* window, int x, int y );

    Camera camera;

private:

    class CameraControlImpl;
    CameraControlImpl* impl;

};

} /* _462 */

#endif /* _462_APPLICATION_CAMERA_CONTROL_HPP_ */

