/**
 * @file math.hpp
 * @brief General math declarations and definitions.
 *
 * @author Eric Butler (edbutler)
 * @author Zeyang Li (zeyangl)
 */

#ifndef _462_MATH_MATH_HPP_
#define _462_MATH_MATH_HPP_

#ifdef WIN32
#define NOMINMAX
#endif

namespace _462 {

// floating point precision set by this typedef
typedef double real_t;

class Vector3;
class Vector4;

#define PI 3.141592653589793238

void color_vector_to_array( const Vector4& color, unsigned char* arr );
Vector4 color_array_to_vector( const unsigned char* arr );

} /* _462 */

#endif /* _462_MATH_462MATH_H_ */

