/**
 * @file p1_2d.hpp
 * @brief Project 1 header for 2d splines.
 *
 * @author Your Name (andrewid)
 */

/*
    EDIT THIS FILE FOR P1.
 */

#ifndef _462_P1_2D_HPP_
#define _462_P1_2D_HPP_

#include "math/math.hpp"
#include <vector>

namespace _462 {

class Vector2;

// A list of 2D vectors
typedef std::vector< Vector2 > ControlPoints;

/**
 * An enumeration of spline types.
 */
enum SplineType 
{
    ST_HERMITE,
    ST_CATMULL_ROM,
    ST_BEZIER
};

void prj_2d_render( const ControlPoints& control_points, SplineType type );

} /* _462 */

#endif /* _462_P1_2D_HPP_ */
