/**
 * @file p1_coaster.cpp
 * @brief Project 1 implementation of roller coaster.
 *
 * @author Your Name (andrewid)
 * @bug Unimplemented.
 */

#include "p1_coaster.hpp"

#include "opengl.hpp"
#include "scene/camera.hpp"

namespace _462 {

/**
 * Initializes the roller coaster.
 * @param points the list of Catmull-Rom control points.
 * @param tau The tension paramter for the spline.
 **/
void p1_coaster_initialize( const CatmullRomControlPointList& points, real_t tau )
{
    glClearColor(0.4, 0.4, 0.4, 1.0);

    // TODO add your initialization code here
}

/**
 * Ticks a frame. This should move the camera along the track.
 * @param model The model to be animated.
 */
void p1_coaster_update( real_t delta_time )
{
    // TODO add your update code here
}

/**
 * Renders the roller coaster
 * @param camera A mouse-controlled camera that you can use for debugging.
 *  This should not actually be used in the final program.
 */
void p1_coaster_render( const Camera& camera )
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glEnable( GL_DEPTH_TEST );

    // set matrices using camera. this isn't actually the correct final
    // behavior, but it's very useful for debugging

    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective( camera.get_fov_degrees(),
                    camera.get_aspect_ratio(),
                    camera.get_near_clip(),
                    camera.get_far_clip() );

    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();

    const Vector3& campos = camera.get_position();
    const Vector3 camref = camera.get_direction() + campos;
    const Vector3 camup = camera.get_up();

    gluLookAt( campos.x, campos.y, campos.z,
               camref.x, camref.y, camref.z,
               camup.x,  camup.y,  camup.z );

    // TODO add your render code here


    // renders a "compass" at the origin. you may find this extremely useful
    // when implementing your code, so we suggest leaving it in at first

    glColor3f(1.0, 0.0, 0.0);
    glBegin(GL_TRIANGLE_FAN);
    glVertex3d(  4.0,  0.0,  0.0 );
    glVertex3d(  0.1,  0.1,  0.1 );
    glVertex3d(  0.1, -0.1,  0.1 );
    glVertex3d(  0.1, -0.1, -0.1 );
    glVertex3d(  0.1,  0.1, -0.1 );
    glVertex3d(  0.1,  0.1,  0.1 );
    glEnd();

    glColor3f(0.0, 1.0, 0.0);
    glBegin(GL_TRIANGLE_FAN);
    glVertex3d(  0.0,  4.0,  0.0 );
    glVertex3d(  0.1,  0.1,  0.1 );
    glVertex3d( -0.1,  0.1,  0.1 );
    glVertex3d( -0.1,  0.1, -0.1 );
    glVertex3d(  0.1,  0.1, -0.1 );
    glVertex3d(  0.1,  0.1,  0.1 );
    glEnd();

    glColor3f(0.0, 0.0, 1.0);
    glBegin(GL_TRIANGLE_FAN);
    glVertex3d(  0.0,  0.0,  4.0 );
    glVertex3d(  0.1,  0.1,  0.1 );
    glVertex3d( -0.1,  0.1,  0.1 );
    glVertex3d( -0.1, -0.1,  0.1 );
    glVertex3d(  0.1, -0.1,  0.1 );
    glVertex3d(  0.1,  0.1,  0.1 );
    glEnd();
}

} /* _462 */

