/**
 * @file p1_model.hpp
 * @brief Project 1 header for roller coaster.
 *
 * @author Your Name (andrewid)
 */

#ifndef _462_P1_COASTER_HPP_
#define _462_P1_COASTER_HPP_

#include "math/vector.hpp"
#include <vector>

namespace _462 {

class Camera;

struct CatmullRomControlPoint
{
    Vector3 position;
    Vector3 up;
};

typedef std::vector< CatmullRomControlPoint > CatmullRomControlPointList;

void p1_coaster_initialize( const CatmullRomControlPointList& points, real_t tau );
void p1_coaster_update( real_t delta_time );
void p1_coaster_render( const Camera& camera );

} /* _462 */

#endif /* _462_P1_COASTER_HPP_ */
