/**
 * @file p1_model.hpp
 * @brief Project 1 header for spline-deformed model.
 *
 * @author Your Name (andrewid)
 */

/*
    EDIT THIS FILE FOR P1.
 */

#ifndef _462_P1_MODEL_HPP_
#define _462_P1_MODEL_HPP_

#include "math/vector.hpp"
#include <vector>

namespace _462 {

class Camera;
class Model;

/**
 * A control point for a Hermite spline.
 */
struct HermiteControlPoint
{
    Vector3 position;
    Vector3 derivative;
    Vector3 up;
};

typedef std::vector< HermiteControlPoint > HermiteControlPointList;

void p1_model_initialize( Model* model, const char* animation_name );
void p1_model_render( const Camera& camera );
void p1_model_update( real_t delta_time );

} /* _462 */

#endif /* _462_P1_MODEL_HPP_ */

